/****************************************************************************
Date: 1/24/97 EXPERIMENTAL
File: debug.cpp
Description:	DEBUG message class
History
*****************************************************************************/

#include "debug.hpp"

#include <stdlib.h>
#include <conio.h>
#include <dos.h>


//private
VOID DEBUG::Print(const CHAR* psz) {
	if (eOn) {
		while(*psz) {
			if (*psz == '\n') {
				putch('\r');
			}
			putch(*psz++);
		}
	}
	return;
}

VOID DEBUG::CRLF() {
	Print("\r\n");
}
	
//public
DEBUG::DEBUG() : eOn(BOOL_TRUE) {}
DEBUG::DEBUG(BOOL eStatus) : eOn(eStatus) {}
DEBUG::DEBUG(const DEBUG& Debug) : eOn(Debug.eOn) {}

DEBUG& DEBUG::operator << (CHAR c) {
	putch(c);
	return *this;
}

DEBUG& DEBUG::operator << (INT i) {
	CHAR buff[20];
	_itoa( i, buff, 10);
	Print(buff);
	return *this;
}

DEBUG& DEBUG::operator << (UINT u) {
	CHAR buff[20];
	_itoa( (INT) u, buff, 16);
	Print("0x");
	Print(buff);
	return *this;
}

DEBUG& DEBUG::operator << (LONG l) {
	CHAR buff[20];
	_ltoa(l, buff, 10);
	Print(buff);
	return *this;
}

DEBUG& DEBUG::operator << (DOUBLE d) {
	CHAR buff[20];
	_ltoa(((LONG) d), buff, 10);
	Print(buff);
	return *this;
}


DEBUG& DEBUG::operator << (const VOID* p) {
	return operator << ((UINT) _FP_OFF(p));
}

DEBUG& DEBUG::operator << (const CHAR* pszString) {
	Print(pszString);
	return *this;
}

VOID	DEBUG::Off() {
	eOn = BOOL_FALSE;
}

VOID	DEBUG::On() {
	eOn = BOOL_TRUE;
}
